//   firmware     USB
//   AVR V-USB (AKA AVR-USB)  custom class
//       - http://www.obdev.at/avrusb/
//    usbFunctionSetup()  - http://microsin.ru
#include <avr/io.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>
#include <util/delay.h>     /*  _delay_ms() */

#include <avr/pgmspace.h>   /*   usbdrv.h */
#include "usbdrv.h"

typedef unsigned char byte;

#define RQ_IO_READ        0x11
#define RQ_IO_WRITE       0x12

byte  dataBuffer[4];

//=============================================================================
//  USB
//=============================================================================
usbMsgLen_t usbFunctionSetup(uchar data[8])
{
  usbRequest_t *rq = (void *)data;
  byte addr = rq->wIndex.bytes[0]; //    
  byte val = rq->wValue.bytes[0];  //     
    
  switch(rq->bRequest){
    //----------------------------------------------------------
    //      /.
    //----------------------------------------------------------
    case RQ_IO_READ:        //     /
      dataBuffer[0] = _SFR_IO8(addr);
      usbMsgPtr = dataBuffer;
      return 1;
    //----------------------------------------------------------
    case RQ_IO_WRITE:       //     /
      _SFR_IO8(addr) = val;
      return 0;
  }
  return 0;   /* default    :       */
}

//-----------------------------------------------------------------------------
int main(void)
{
  uchar   i;

  wdt_enable(WDTO_1S);
  /*    watchdog,   .   
      watchdog (on/off, period)   !
  */
  /*  RESET:          (pull-up).
      ,    D+ and D-,  ,      
     .
  */
  usbInit();              // . usbdrv.h  usbdrv.c
  usbDeviceDisconnect();  /* . usbdrv.h -  ,  ,   ! */
  i = 0;
  while(--i){            /*  USB disconnect   > 250 ms */
    wdt_reset();
    _delay_ms(1);
  }
  usbDeviceConnect();     // . usbdrv.h

  sei();
  for(;;){                /*    */
    wdt_reset();
    usbPoll();
  }
  return 0;
}
//-----------------------------------------------------------------------------
